<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: admin.inc.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	// Loading APIs
	LoadLib (
		'categories',
		'users',
		'format.lib.php',
		'blog'
	);

	// Setting URL Prototype and extracting variables to current scheme
	Extract (
		URLGetArgs('null/null/action=alpha?page=page&id=int')
	);

	switch ($action) {
		case "edit":
			if ($id) {

				// creating a new block
				$tpl = new ContentBlock();

				// this block is almost empty, we need to insert some templates into it
				$tpl->insert("BLOCK_CONTENT", "blog/admin.tpl");

				// main query
				$db->query("
					SELECT
						id, userid, category, icon, title, content, footer, creationtime,
						status, allowcomments
					FROM ".db_table("blog")." WHERE id = '{$id}'
				");

				if ($db->num_rows()) {

					// fetching and sanitising data
					$row = $db->fetch_row();
					saneHTML($row, "content");

					$tpl->set_arr($row);

					$tpl->set_arr (
						Array (
							"BLOCK_TITLE"			=> _l("L_BLOG"),
							"BLOCK_SUBTITLE"		=> _l("L_EDIT"),
							"BLOCK_ICON"			=> mkIcon("blog", 16),
							//"CONTENT"				=> user_env_vars($row["content"]),
							"ACTION"				=> "edit"
						)
					);

					// compiling content block
					$mcBuff = $tpl->make();
				}
			}
		break;
		default:

			// creating a content block
			$tpl = new ContentBlock();

			// inserting templates in that content block
			$tpl->insert("BLOCK_CONTENT", "blog/admin.tpl");

			// creating a pager
			$pager = $db->pager (
				"SELECT id FROM ".db_table("blog")."
				ORDER BY status ASC, creationtime DESC ",
				"index.php/module=admin/admin=blog?page=%p", $page,
				conf::getkey('blog', 'items_per_admin_page')
			);

			// querying items for specified $page
			$db->query ("
				SELECT
				id, userid, category, icon, title, content, creationtime, status
				FROM ".db_table("blog")."
				ORDER BY status ASC, creationtime DESC {$pager['sql']}
			", __FILE__, __LINE__);

			$entries = $db->num_rows();

			while ($row = $db->fetch_row()) {

				// sanitizing all variables but 'content', it should be
				// cleaned using another function
				saneHTML ($row, 'content');

				$row["title"] = $row['status'] ? $row['title'] : $row['title'].' ('._L('L_DRAFT').')';

				$row["ACTIONS"] = new tplButtonBox();
				$row["ACTIONS"]->add (
					mkLink("index.php/module=admin/base=blog/action=edit?id={$row['id']}", _L('L_EDIT'), "edit.png"),
					mkLink("modules/blog/main.act.php?action=delete&id={$row['id']}&auth="._L('C_AUTH_STR'), _l("L_DELETE"), "delete.png", true)
				);
				if (!$row["status"])
					$row["ACTIONS"]->add(mkLink("modules/blog/main.act.php?action=publish&id={$row['id']}&auth="._L("C_AUTH_STR")."", _L("L_PUBLISH")));
				$row["ACTIONS"] = $row["ACTIONS"]->make();

				$tpl->set_arr ($row, "ENTRY");

				// saving 'entry' sub-block
				$tpl->saveBuff("ENTRY");
			}

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE"		=> _l("L_BLOG"),
					"BLOCK_SUBTITLE"	=> _l("L_COMPOSE"),
					"BLOCK_ICON"		=> mkIcon("blog.png", 16),
					"ICON"				=> "blog.png",
					"STATUS"			=> 1,
					"CATEGORY"			=> null,
					"ACTION"			=> "post",
					"ALLOWCOMMENTS"		=> 1,
					"TITLE"				=> "",
					"CONTENT"			=> "",
					"FOOTER"			=> "",
					"ID"				=> 0,
					"RETURN"			=> "",
					"PAGER"				=> $pager["html"]
				)
			);

			// main block compilation
			$mcBuff = $tpl->make();
		break;
	}
?>