<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: archive.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Archive</title>
			<description>Shows blog entries archive sorted by month for the last year</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
	</blockscript>
	<%%>
	*/

	LoadLib('categories');

	// last year (this month, this day)
	$lower_ts = mktime(0, 0, 0, date("n"), date("j"), date("Y")-1);

	// events counter
	$events = Array();

	// SQL category lock
	$cat_lock = cache_func('categories::fetchAllowed', true);

	// querying blog entries for the last year
	$q = $GLOBALS["db"]->query("SELECT id, title, creationtime
	FROM ".db_table("blog")."
	WHERE ($cat_lock) AND status = '1' AND creationtime >= '{$lower_ts}'
	ORDER BY creationtime DESC",
	__FILE__, __LINE__, true);

	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		saneHTML($row);
		$month = date("Y.n", $row["creationtime"]);
		// adding event to $month index
		$events[$month] = isset($events[$month]) ? $events[$month]+1 : 1;
	}

	$last_year = false;
	foreach ($events as $month => $counter) {
		list($year, $month) = explode(".", $month);
		// checking for year change
		if ($last_year != $year) {
			$return .= "<h4>$year</h4>\n";
			$last_year = $year;
		}
		// adding link that will show blog entries for this month
		$return .= "<a href=\"".URLEvalPrototype("index.php/module=blog?date=$year.$month")."\">".htmlentities(ucwords(strftime("%B %Y ($counter)", mktime(0,0,0,$month,1,$year))))."</a><br />\n";
	}
?>