<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: most_popular_posts.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-BLOCK")) die();

	/*
	<%%>
	<?xml version="1.0" encoding="UTF-8"?>
	<blockscript>
		<info lang="en">
			<title>Most popular posts</title>
			<description>Lists the most popular posts</description>
			<author><![CDATA[xiam &lt;<a href="mailto:xiam@users.sourceforge.net">xiam@users.sourceforge.net</a>&gt;]]></author>
			<homepage><![CDATA[<a href="http://www.gekkoware.org">http://www.gekkoware.org</a>]]></homepage>
		</info>
		<variable name="limit">5</variable>
		<variable name="preview">0</variable>
		<variable name="catid">0</variable>
	</blockscript>
	<%%>
	*/

	LoadLib (
		"categories", "format.lib.php"
	);

	$cat_lock = cache_func("Categories::fetchAllowed", true);

	// querying for the latests items
	$q = $GLOBALS["db"]->query("SELECT
	id, userid, category, icon, title, content, creationtime, pagereads
	FROM ".db_table("blog")."
	WHERE status = '1' AND ($cat_lock) ".($catid ? "AND category = '{$catid}'" : "")."
	ORDER BY pagereads DESC LIMIT {$limit}",
	__FILE__, __LINE__, true);

	$return = Array();
	while ($row = $GLOBALS["db"]->fetch_row($q)) {
		// mkintro will strip all html for post content
		saneHTML($row, "content");
		// adding link
		if ($preview) {
			$return[] = "<h4><a href=\"".URLEvalPrototype("index.php/module=blog/action=view/title=".title_encode($row["title"])."?id={$row['id']}")."\" title=\"".dateFormat($row["creationtime"])."\">".mkIcon($row["icon"] ? $row["icon"] : "blog.png")." {$row["title"]}</a></h4>".mkIntro($row["content"], 120)."<br /><div class=\"small\" style=\"text-align:right\"><b>"._l("L_POSTED_BY").":</b> ".cache_func('Users::mkUserLink', $row['userid'])."</div>\n";
		} else {
			$return[] = "<a href=\"".URLEvalPrototype("index.php/module=blog/action=view/title=".title_encode($row["title"])."?id={$row['id']}")."\" title=\"".htmlspecialchars(mkIntro($row["content"], 120))."\">".mkIcon($row["icon"] ? $row["icon"] : "blog.png")." {$row["title"]}</a>";
		}
	}
	//
	$return = implode("<hr />\n", $return);

?>