<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	// loading main configuration
	require_once "../../conf.php";

	// loading some other libraries & api's
	LoadLib (
		"format.lib.php",
		"blog"
	);

	// authentication script
	require_once "../../lib/auth.inc.php";

	// importing some general variables that could be used in most procedures
	varImport ("action", "id", "return");

	// unprivileged user tasks
	switch ($action) {
		default:
			//foo();
		break;
	}

	// module administrator tasks
	if (is_admin()) {
		switch ($action) {
			case "delete":
				execWithEach($id, "Blog::deleteItem");
			break;
			case "publish":
				Blog::setItemStatus($id, 1);
			break;
			case "post":

				// all those variables below are supposed to be sent over a form.
				// after importing them, those variables becomes globals.
				varImport (
					"icon", "status", "category", "title", "content", "footer",
					"allowcomments"
				);

				// variables below are required to continue.
				varRequire (
					"category", "title", "content"
				);

				// checking access (for avoiding flood)
				$AccessTable->load_rule($AccessTable->set_generic_rule("blog", "post"), "E_ANTI_FLOOD");

				// html generated by the rtbEditor is not standard and needs to be
				// fixed before inserint this post into the database
				rtb_codefix($content);

				// inserting the new entry into the database
				$db->query ("
				INSERT INTO ".db_table("blog")."
					(
						id,
						userid,
						category,
						icon,
						title,
						content,
						footer,
						creationtime,
						status,
						allowcomments
					)
						VALUES
					(
						'".$db->free_id("blog")."',
						'{$USER["id"]}',
						'{$category}',
						'{$icon}',
						'{$title}',
						'{$content}',
						'{$footer}',
						'".time()."',
						'{$status}',
						'{$allowcomments}'
					)
				", __FILE__, __LINE__);

				$return = urlEvalPrototype("index.php/module=admin/base=blog", true, false);
				
				slog("blog: created entry '$title'", "actions", 1);
			break;
			case "edit":

				// all those variables below are supposed to be sent over a form.
				// after importing them, those variables becomes globals.
				varImport (
					"icon", "status", "category", "title", "content", "footer",
					"allowcomments"
				);

				// variables below are required to continue.
				varRequire (
					"id", "category", "title", "content"
				);

				// is this entry already posted?
				$ptime = false;
				$db->query("SELECT status FROM ".db_table("blog")." WHERE id = '{$id}'");
				$row = $db->fetch_row();
				if (!$row["status"])
					$ptime = true;

				// html generated by the rtbEditor is not standard and needs to be
				// fixed before inserint this post into the database.
				rtb_codefix($content);

				$db->query("
					UPDATE ".db_table("blog")." SET
						category 		= '{$category}',
						icon 			= '{$icon}',
						title 			= '{$title}',
						content 		= '{$content}',
						footer 			= '{$footer}',
						status 			= '{$status}',
						".($ptime ? "creationtime = '".time()."',": "")."
						allowcomments	= '{$allowcomments}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

				$return = urlEvalPrototype("index.php/module=admin/base=blog", true, false);
				
				slog("blog: updated entry '$id'", "actions", 1);
			break;
		}
	}

	redirect($return);

	db_exit();
?>