<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	// Loading some libraries that will be used in this script
	LoadLib (
		'categories',		// module api
		'comments',			// module api
		'users',			// module api
		'feeder.lib.php',	// core api
		'blog'
	);

	// This is a URL prototype, below you can specify the way you want to load your variables
	Extract (
		URLGetArgs('/null/action=alpha/type=string?id=int&page=page&cpage=page&user=alpha&category=string&date=date&path=string&full=int')
	);

	// Setting default values when no ones were met for variables below

	switch ($action) {
		case "feed": {

			define ("GEKKO_USE_ABSOLUTE_URLS", true);

			if (!$type)
				$type = "rss";

			if ($category)
				$category = Categories::getID($category);

			if ($user)
				$userid = Users::getID($user);

			if (!$user || $userid) {

				// removing extension
				$type = preg_replace("/\..*/", "", $type);

				// creating feeder
				$feed = new XMLFeed($type);

				// category lock
				$catg_lock = cache_func('categories::fetchAllowed', true, "category", "*");

				// main query
				$db->query ("
				SELECT
					id, userid, title, content, creationtime, category
				FROM ".db_table("blog")."
				WHERE status = '1'
				".(isset($userid) ? "AND userid='{$userid}' " : "")."
				AND ($catg_lock)
				".($category ? "AND (".categories::match($category).")" : "")."
				ORDER BY creationtime ".($full ? "": "DESC LIMIT ".conf::getkey('blog', 'feed_items', 30, 'i'))."
				", __FILE__, __LINE__);

				// adding each listed item
				if ($db->num_rows()) {
					while ($row = $db->fetch_row()) {
						// filtering html according user privileges
						Format::Style($row["content"], $row["userid"]);

						$row["CATEGORY"] = cache_func("Categories::getCategory", $row["category"], true);
						$row["LINK"] = urlevalprototype("index.php/module=blog/action=view/title=".title_encode($row["title"])."?id={$row["id"]}");
						$row["PERMALINK"] = urlevalprototype("index.php/module=blog/action=permalink?path={$row["id"]}.{$row["creationtime"]}");
						$row["COMMENTS"] = urlevalprototype("index.php/module=blog/action=view/title=".title_encode($row["title"])."?id={$row["id"]}#comment");

						$feed->addItem($row);
					}
					// that's all folks! (outputting buffer and closing connections)
					abort($feed->serve($type));
				}
			}

			abort("empty feed.");

			break;
		}
		case "permalink":

			preg_match("/(\d*).(\d*)/", $path, $match);

			if (isset($match[2])) {

				list($buff, $id, $creationtime) = $match;
				unset($match);

				$db->query("SELECT title FROM ".db_table("blog")." WHERE id = '{$id}' AND
				creationtime = '{$creationtime}'", __FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					abort(redirect(urlevalprototype("index.php/module=blog/action=view/title=".title_encode($row["title"])."?id={$id}", true, false)));
				} else {
					abort(redirect(urlevalprototype("index.php/module=blog?message=".urlencode(_l("L_UNKNOWN_PERMALINK"))."&type=error", true, false)));
				}
			} else {
				abort(redirect(urlevalprototype("index.php/module=blog")));
			}
		break;
		case "view":

			// querying for blog entry
			$db->query("
				SELECT
				id, userid, category, icon, title, content, footer, creationtime,
				allowcomments
				FROM ".db_table("blog")." WHERE status = '1' AND id='{$id}'
			", __FILE__, __LINE__);

			// dows this entry exists?
			if ($db->num_rows()) {

				// creating content block
				$tpl = new ContentBlock();
				$tpl->load("blog/view.tpl");

				$row = $db->fetch_row();

				// is the user allowed to see topics under this category?
				if (categories::auth($row["category"])) {

					// sanitising all variables but 'content' and 'footer'
					saneHTML($row, "content,footer");

					// filtering remaining variables according to author's privileges
					Format::Style($row["content"], $row["userid"]);
					Format::Style($row["footer"], $row["userid"]);

					$row["title_link"] = $row["title"];

					// setting variables in content-block's schema
					$tpl->set_arr($row);

					// modifying block variables
					$tpl->set_arr (
						Array (
							'CATEGORY'			=> Categories::getCategory($row["category"]),
							'PERMALINK'			=> blog::createPermalink($row),
							"PAGE"				=> $page
						)
					);

					// compiling template,
					$mcBuff = $tpl->make();

					// setting main page's title to this item's title since it's the
					// most important showed information
					title_attach($row["title"], 1);

					// incrementing 'pagereads' counter
					$db->query("UPDATE ".db_table("blog")."
					SET pagereads=pagereads+1 WHERE id='{$id}'",
					__FILE__, __LINE__);

				} else {

					$mcBuff = AccessDenied();
					break;

				}
			break;
		}
		default:

			// creating a special sql condition when a date is specified.
			$date_lock = $date ? SQLDateLock('creationtime', $date) : '1';

			// creating a aspecial sql condition for listing entries within allowed
			// categories only
			$catg_lock = cache_func('categories::fetchAllowed', true);

			$categoryid = categories::getID($category);

			// this function will calculate SQL LIMIT according to the selected page
			// number.
			$pager = $db->pager (
				"SELECT id FROM ".db_table("blog")."
				WHERE status = '1' AND ($date_lock) AND ($catg_lock) ".($category ? " AND category='$categoryid'": "")."",
				"index.php/module=blog?page=%p".($category ? "&category=".title_encode($category) : "")."", $page,
				conf::getkey("blog", "items_per_page")
			);
			// take a look at print_r($pager);

			// main SQL query, listing all items with some restrictions
			$db->query ("
			SELECT
				id, userid, category, icon, title, content, footer, creationtime,
				allowcomments
			FROM ".db_table("blog")."
			WHERE status = '1' AND ($date_lock) AND ($catg_lock) ".($categoryid ? " AND category='$categoryid'" : "")."
			ORDER BY creationtime DESC {$pager['sql']}
			", __FILE__, __LINE__);

			if ($db->num_rows()) {

				// creation new content block.
				$tpl = new ContentBlock();
				$tpl->load("blog/index.tpl");

				// since we're going to ch
				// parseing contents
				while ($row = $db->fetch_row()) {

					// cleaning html for all items but 'content' and 'footer'
					saneHTML($row, "content,footer");

					// html filtering according user's privileges
					Format::introStyle($row["content"], $row["userid"]);
					Format::Style($row["footer"], $row["userid"]);

					// cacheing common variables
					$catg_name = cache_func('Categories::getCategory', $row['category'], true);

					$row["title_link"] = mklink("index.php/module=blog/action=permalink?path={$row["id"]}.{$row["creationtime"]}", $row["title"]);

					$tpl->set_arr($row, "POST");

					// variables passed to block's schema
					$tpl->set_arr (
						Array (
							'CATEGORY'		=> mkLink("index.php/module=blog?category=".title_encode($catg_name), $catg_name),
							'PERMALINK'		=> blog::createPermalink($row)
						),
						"POST"
					);

					// compiling template.
					$tpl->saveBuff("POST")."\n";
				}

				$tpl->set_arr (
					Array (
						"PAGER"	=> $pager["html"]
					)
				);

				$mcBuff = $tpl->make();

				// attaching link for RSS feeders.
				htdoc_attach("HEAD", '<link rel="alternate" type="application/rss+xml" title="'._l("C_SITE.TITLE").'" href="'._l("C_SITE.URL").'index.php/blog/feed/rss.xml" />');

				// attaching nice XML buttons at page's footer.
				htdoc_attach("FOOTER", mkFeederButtons("index.php/module=blog/action=feed/type=%s".($category ? "?category=".str_replace("%", "%%", title_encode($category)) :"")));

			}
		break;
	}

?>