<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: module.inc.php,v 1.1.1.1 2006/02/20 21:52:22 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	// module's specification an installation instructions
	Class GekkoModule_Blog {
		function create_menu() {
			// returning 'false' means you want gekko to create a default menu entry
			return false;
		}
		function configure() {
			// default values for configuration keys (use ::getKey instead of setKey,
			// because getKey could create the key _only_ if it doesn't exists) and
			// setKey will _overwrite_ it.
			Conf::getKey("blog", "items_per_page",			12,		"i");
			Conf::getKey("blog", "items_per_admin_page",	25,		"i");
			Conf::getKey("blog", "allow_user_comments",		1, 		"b");
		}
		function install() {

			// creating tables for this module
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("blog")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				userid MEDIUMINT (8) UNSIGNED NOT NULL,
				category SMALLINT (5) UNSIGNED NOT NULL,
				icon VARCHAR (64) NOT NULL default 'blog.png',
				title VARCHAR (128),
				content TEXT,
				footer VARCHAR (255),
				creationtime INT (11) UNSIGNED NOT NULL,
				status ENUM('0','1') NOT NULL default '1',
				pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				allowcomments ENUM('0','1') NOT NULL default '1'
			)", __FILE__, __LINE__, true);

			// registering module (this is not done automatically)
			modCore::registerModule($GLOBALS["cgdb"]["blog"], "blog", "*", $GLOBALS["cgdb"]["blog"]);
		}
		function uninstall() {
			// dropping tables (additional job is made automatically)
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("blog"), __FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			// applying patches according to new module's version
			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				// fixes bugs when using MySQL5
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("blog")."
				CHANGE COLUMN status status ENUM('0','1') NOT NULL default '1',
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
			if (Packages::checkVersion("0.5.9", $provided_v) < 0) {
				$GLOBALS["db"]->query ("ALTER TABLE ".db_table("blog")."
				CHANGE COLUMN icon icon VARCHAR (64) NOT NULL default 'blog.png',
				CHANGE COLUMN userid userid MEDIUMINT (8) UNSIGNED NOT NULL,
				ADD COLUMN pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0 AFTER status",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {
			// if this module depends on other and it is uninstalled...
		}
	}
?>